SystemOrganization addCategory: #'Rizel-Spy-Profiler-Tests'!

AbstractSpyTest subclass: #RzProfilerSpyTest
	instanceVariableNames: ''
	classVariableNames: 'cache'
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler-Tests'!

!RzProfilerSpyTest commentStamp: '<historical>' prior: 0!
A RzProfilerSpyTest is a test class for testing the behavior of RzProfilerSpy!

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:34'!
cache
	cache ifNil:[ 
		Transcript show:'2'.
		cache := 2].
	^ cache! !

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:33'!
cache: anObject
	cache := anObject! !

!RzProfilerSpyTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:33'!
reset
	cache := nil.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:53'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).
	mp3s add: (RSMP3File named:'MP3E' size:10).
	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 14:30'!
testBasic
	"
	self new testBasic
	"
	|profile|
	
	profile := RzProfilerSpy profile: [
		RSImageFile named: 'TestImage.jpg'.
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: (profile packages size = 1).	
	self assert: (profile allMethods notEmpty).	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 19:41'!
testCofigurationCategories
	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 01:08'!
testCoverage
	"
	self new testBasic
	"
	|profile image time|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	time := (profile>>#RSImageFile>>#open) executionTime.

	self assert: (profile allCoveredClasses size > 1).
	self assert: (profile allCoveredMethods size > 1).
	self assert: (profile coverage > 0).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 14:36'!
testNumberOfCalls
	"
	self new testNumberOfCalls
	"
	|profile image noc|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	noc := (profile numberOfCalls).
	Transcript show: noc asString.
	
	self assert: ( noc > 3000).
	self assert: ( noc < 3020).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 12/14/2012 14:45'!
testNumberOfCalls2
	"
	self new testNumberOfCalls2
	"
	|profile image noc|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		image open.
		] inClassCategory:'Rizel-Test-Scenario'.
	profile inspect.
	noc := (profile >>#RSImageFile >>#open) numberOfCalls.
	self assert: ( noc > 10).
	self assert: ( noc < 80).! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:33'!
testNumberOfExecution
	"
	self new testBasic
	"
	|profile image|
	
	image := RSImageFile named: 'TestImage.jpg' size: 10.
	profile := RzProfilerSpy profile: [
		10 timesRepeat: [image size].
		] inClassCategory:'Rizel-Test-Scenario'.

	self assert: ( (profile>>#RSFile>>#size) numberOfExecutions =10).	
	! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:10'!
testScenario
	self buildPendrive.! !

!RzProfilerSpyTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 22:14'!
testScenario2
	|pen|
	pen := self buildPendrive.
	
	self assert: ((pen collect:[ :file |  file class = RSTextFile]) size = 6).! !
